/* widgets.sql - metadata for form widgets */

/* insert form widgets and params */
create or replace function inline_0 ()
returns integer as '
declare
  v_template_id         integer;
begin

  raise notice ''Creating template::element::create proc...'';

  perform dtype_proc__create(''template::element::create'');

  perform dtype_proc_param__create(
    1, 
    ''template::element::create'', 
    ''label'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    2, 
    ''template::element::create'', 
    ''validate'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    3, 
    ''template::element::create'', 
    ''datatype'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    4, 
    ''template::element::create'', 
    ''optional'',
    ''switch:boolean'',
    ''t'',
    ''f''
  );

  perform dtype_proc_param__create(
    5, 
    ''template::element::create'', 
    ''options'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    6, 
    ''template::element::create'', 
    ''value'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    7, 
    ''template::element::create'', 
    ''values'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    8, 
    ''template::element::create'', 
    ''sign'',
    ''switch:boolean'',
    ''t'',
    ''f''
  );

  perform dtype_proc_param__create(
    9, 
    ''template::element::create'', 
    ''section'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    10, 
    ''template::element::create'', 
    ''display_value'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    11, 
    ''template::element::create'', 
    ''before_html'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    12, 
    ''template::element::create'', 
    ''after_html'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    13, 
    ''template::element::create'', 
    ''help_text'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    14, 
    ''template::element::create'', 
    ''nospell'',
    ''switch:boolean'',
    ''t'',
    ''t''
  );

  perform dtype_proc_param__create(
    100, 
    ''template::element::create'', 
    ''html,size'',
    ''switch:spec'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    101, 
    ''template::element::create'', 
    ''html,maxlength'',
    ''switch:spec'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    102, 
    ''template::element::create'', 
    ''html,rows'',
    ''switch:spec'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    103, 
    ''template::element::create'', 
    ''html,cols'',
    ''switch:spec'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    104, 
    ''template::element::create'', 
    ''html,wrap'',
    ''switch:spec'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    200, 
    ''template::element::create'', 
    ''htmlarea_p'',
    ''switch:boolean'',
    ''t'',
    ''f''
  );

  perform dtype_proc_param__create(
    210, 
    ''template::element::create'', 
    ''format'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    211, 
    ''template::element::create'', 
    ''year_interval'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    220, 
    ''template::element::create'', 
    ''search_query'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    221, 
    ''template::element::create'', 
    ''result_datatype'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  perform dtype_proc_param__create(
    300, 
    ''template::element::create'', 
    ''style'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  -- TODO: HACK! This shouldn;t be here it should be some
  -- TODO  kind of extension otherwise other packages 
  -- TODO  have to keep adding stuff to dynamic types
  -- TODO  Excuse me while I try not to vomit
  perform dtype_proc_param__create(
    301, 
    ''template::element::create'', 
    ''hide_extension_number'',
    ''switch:onevalue'',
    ''f'',
    null
  );

  raise notice ''Inserting standard datatype metadata...'';
  insert into dtype_db_datatypes (datatype, db_type)
  values (''boolean'', ''boolean'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''number'', ''real'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''integer'', ''integer'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''money'', ''text'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''date'', ''timestamp'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''timestamp'', ''timestamp'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''time_of_day'', ''timestamp'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''enumeration'', ''text'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''url'', ''text'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''email'', ''text'');
  insert into dtype_db_datatypes (datatype, db_type)
  values (''text'', ''text'');

  raise notice ''Inserting standard widget metadata...'';

  insert into dtype_widgets (widget) values (''text'');
  insert into dtype_widgets (widget) values (''textarea'');
  insert into dtype_widgets (widget) values (''richtext'');
  insert into dtype_widgets (widget) values (''radio'');
  insert into dtype_widgets (widget) values (''checkbox'');
  insert into dtype_widgets (widget) values (''select'');
  insert into dtype_widgets (widget) values (''multiselect'');
  insert into dtype_widgets (widget) values (''date'');
  insert into dtype_widgets (widget) values (''search'');
  insert into dtype_widgets (widget) values (''hidden'');

  -- TODO: HACK! See telecom_number vomit related message above
  insert into dtype_widgets (widget) values (''telecom_number'');


  return 0;
end;' language 'plpgsql';

select inline_0 ();

drop function inline_0 ();
