<?xml version="1.0"?>
<queryset>
   <rdbms><type>postgresql</type><version>7.1</version></rdbms>

<fullquery name="dtype::create.create_type">      
      <querytext>

          select dynamic_type__create_type (
                :name,
                :supertype,
                :pretty_name,
                :pretty_plural,
                :table_name,
                :id_column,
                :name_method
          );

      </querytext>
</fullquery>

<fullquery name="dtype::delete.drop_type">      
      <querytext>

          select dynamic_type__drop_type (
                :name,
                :drop_children,
                :drop_table
          );

      </querytext>
</fullquery>

<fullquery name="dtype::create_attribute.create_attr">      
      <querytext>

          select dynamic_type__create_attribute (
                :object_type,
                :name,
                :datatype,
                :pretty_name,
                :pretty_plural,
                :sort_order,
                :default_value,
                :column_spec
          );

      </querytext>
</fullquery>

<fullquery name="dtype::get_attributes_list.select_attributes">      
      <querytext>
      select a.attribute_name as name, 
             a.pretty_name,
             a.attribute_id,
             a.datatype,
             a.table_name,
             coalesce(a.column_name, a.attribute_name) as column_name,
             a.default_value,
             a.min_n_values,
             a.max_n_values,
             a.storage,
             a.static_p
      from acs_object_type_attributes a
           join acs_object_types ot using (object_type)
      where a.object_type = :name
      $storage_clause
      order by ot.tree_sortkey, a.sort_order
      </querytext>
</fullquery>

<fullquery name="dtype::delete_attribute.drop_attr">      
      <querytext>

          select dynamic_type__drop_attribute (
                :object_type,
                :name,
                :drop_column
          );

      </querytext>
</fullquery>

</queryset>
