ad_page_contract {

    @author Timo Hentschel (timo@timohentschel.de)
    @creation-date 2005-06-05
    @cvs-id $Id: element-param.tcl,v 1.1 2005/12/13 02:59:46 dblue Exp $

} {
    {form_id:notnull}
    {object_type:notnull}
    {element_id:notnull}
    {param_id:notnull}
    {value_id:optional}
}

set user_id [auth::require_login]
permission::require_permission -object_id [ad_conn package_id] -privilege admin

acs_object_type::get -object_type $object_type -array type_info
db_0or1row get_data {}

if {[info exists value_id]} {
    set page_title "Edit parameter value"
} else {
    set page_title "Add parameter value"
}

set context [list [list [export_vars -base dtype {object_type}] $type_info(pretty_name)] [list [export_vars -base form {object_type form_id}] "Form"] [list [export_vars -base element-params {object_type form_id element_id}] "Params"] $page_title]


set source_options [list [list "[_ dynamic-types.param_source_literal]" literal] [list "Scope" scope] [list "Proc" proc]]

ad_form -name parameter_form -export {object_type form_id element_id param_id} -form {
    {value_id:key(t_dtype_seq)}
    {param_source:text(select) {label "[_ dynamic-types.param_source]"} {options $source_options} {help_text "[_ dynamic-types.param_source_help]"}}
    {value:text(textarea) {label "[_ dynamic-types.param_value]"} {html {rows 5 cols 80}} {help_text "[_ dynamic-types.param_value_help]"}}
} -new_request {
    # get default value
    db_1row get_default "select default_value as value from dtype_proc_params where param_id=:param_id"
} -edit_request {
    db_1row get_param_data {}
} -new_data {
    dtype::element::add_parameter -element_id $element_id -param $param -value $value -source $param_source
} -edit_data {
    dtype::element::delete_parameter -element_id $element_id -param $param
    dtype::element::add_parameter -element_id $element_id -param $param -value $value -source $param_source
} -after_submit {
    ad_returnredirect [export_vars -base element-params {object_type form_id element_id}]
    ad_script_abort
}

ad_return_template
