ad_page_contract {

    @author Timo Hentschel (timo@timohentschel.de)
    @creation-date 2005-06-05
    @cvs-id $Id: element-params.tcl,v 1.1 2005/12/13 02:59:46 dblue Exp $

} {
    {object_type:notnull}
    {form_id:notnull}
    {element_id:notnull}
}

set user_id [auth::require_login]
permission::require_permission -object_id [ad_conn package_id] -privilege admin

acs_object_type::get -object_type $object_type -array type_info
db_1row get_data {}

set page_title "[_ dynamic-types.parameters]"
set context [list [list [export_vars -base dtype {object_type}] $type_info(pretty_name)] [list [export_vars -base form {object_type form_id}] "[_ dynamic-types.form_one]"] $page_title]

# Show 2 lists. 
# First is list of parameters which have values SET.
# Second is a list of parameters which are NOT SET.
# Allow user to unset values only if the parameter is not required
# Allow user to set a parameter value, which moves it from the second list to the first

list::create \
    -name set_params \
    -multirow set_params \
    -key param_id \
    -row_pretty_plural "[_ dynamic-types.params]" \
    -pass_properties {
        object_type form_id element_id
    } -elements {
        name {
            label "[_ dynamic-types.param_name]"
            link_url_eval {[export_vars -base element-param {object_type form_id element_id param_id value_id}]}
        }
        param_type {
            label "[_ dynamic-types.param_type]"
        }
        value {
            label "Value"
        }
        is_required {
            label "Unset"
            display_eval {[ad_decode $is_required t "Required" "Delete"]}
            link_url_eval {[ad_decode $is_required t "" [export_vars -base element-param-del {object_type form_id element_id name}]]}
        }
    } 

dtype::proc::param_values -proc template::element::create -call_id $element_id -multirow set_params

list::create \
    -name unset_params \
    -multirow unset_params \
    -key param_id \
    -row_pretty_plural "Possible parameters" \
    -pass_properties {
        object_type form_id element_id
    } -elements {
        name {
            label "[_ dynamic-types.param_name]"
            link_url_eval {[export_vars -base element-param {object_type form_id element_id param_id}]}
        }
        param_type {
            label "[_ dynamic-types.param_type]"
        }
    } 

db_multirow unset_params get_unused_params "select param_id, name, param_type from dtype_proc_params where proc = 'template::element::create' and param_id not in (select param_id from dtype_proc_param_values where call_id = :element_id)"

ad_return_template
