ad_page_contract {

    @author Timo Hentschel (timo@timohentschel.de)
    @creation-date 2005-05-02
    @cvs-id $Id: index.tcl,v 1.1 2005/12/13 02:59:46 dblue Exp $
} {
    {orderby "pretty_name,asc"}
}

set page_title "[_ dynamic-types.dynamic_types]"
set context [list $page_title]

list::create \
    -name dtypes \
    -multirow dtypes \
    -key object_type \
    -actions [list "[_ dynamic-types.add]" [export_vars -base dtype-add] "[_ dynamic-types.add_type]"] \
    -row_pretty_plural "[_ dynamic-types.dynamic_types]" \
    -bulk_actions [list "[_ dynamic-types.export]" dtypes-code "[_ dynamic-types.code_export]"] \
    -elements {
        pretty_name {
            label "[_ dynamic-types.pretty_name]"
            link_url_eval $dtype_url
            orderby "lower(pretty_name)"
        }
        object_type {
            label "[_ dynamic-types.object_type]"
            orderby "object_type"
        }
        delete {
            label "Delete"
            display_template "<a href=\"@dtypes.delete_url@\">delete</a>"
        }

    }

set orderby_clause [list::orderby_clause -orderby -name dtypes]

db_multirow -extend { dtype_url delete_url } dtypes select_dtypes {} {
    set dtype_url [export_vars -base dtype {object_type}]
    set delete_url [export_vars -base dtype-delete {object_type}]
}
